<?php

namespace App\Http\Controllers;

use App\Models\Batiment;
use App\Models\BatimentUnite;
use App\Models\Unite;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use RealRashid\SweetAlert\Facades\Alert;

class BatimentUniteController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $batiment =Batiment::all();
        $unite = Unite::all();

       return view('Admin.pages.File_BatimentUnite.BatimentUnite',compact('batiment','unite'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $donnees = DB::table('batiment_unites')
        ->join('batiments', 'batiment_unites.batiment_id', '=', 'batiments.id')
        ->join('unites', 'batiment_unites.Unite_id', '=', 'unites.id')
        ->select('batiment_unites.id', 'batiments.nomBatiment', 'unites.code_Unite')
        ->get();
        // Remplacez "VotreModele" par le nom de votre modèle de données

    return response()->json($donnees);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = array(
            'Unite_id' => 'required',
            'batiment_id' => 'required',
        );

        $error = Validator::make($request->all(), $rules);

        if ($error->fails()) {
            Alert::toast('Add success','success');

            return redirect()->back()->withErrors($error)->withInput();
        }

        try {
            $form_data = array(

                'Unite_id' => $request->Unite_id,
                'batiment_id' => $request->batiment_id,

            );
            BatimentUnite::create($form_data);
            Alert::toast('Add success','success');
            return redirect()->back()->withInput();
        } catch (\Illuminate\Database\QueryException $exception) {
        Alert::toast('Une erreur s\'est produite lors de l\'ajout','error' /*. $exception->getMessage()*/);
            return redirect()->back()->withInput();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request)
    {


    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
      public function edit($id)
    {
        $BatimentsUnites = BatimentUnite::find($id);
        return response()->json([
            'status' => 200,
            'BatimentsUnites' => $BatimentsUnites,
        ]);
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        //la route update a été détacher de la route ressource  (faite un php artisan route:list)
        $BatimentUnites_id = $request->input('id');
        $BatimentUnites = BatimentUnite::find($BatimentUnites_id);
        try {
            $BatimentUnites->Unite_id = $request->input('Unite_id');
            $BatimentUnites->batiment_id = $request->input('batiment_id');
            $BatimentUnites->update();
            Alert::toast('Update success','success');
            return redirect()->route('Unite.index');
        } catch (\Illuminate\Database\QueryException $exception) {
            Alert::toast('Veuillez rempli tous champs','error');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {

        $data_id = $request->input('deleteBatimentUnites');
        $data = BatimentUnite::find($data_id);

        try {
            $data->delete();
            Alert::toast('Delete success','success');
        } catch (\Illuminate\Database\QueryException $exception) {
            $errorInfo = $exception->errorInfo;

            if ($errorInfo[0] === '23000' && $errorInfo[1] === 1451) {
                $affectedTables = $this->getAffectedTables($errorInfo[2]);
                $errorMessage = "Impossible de supprimer l'événement. Il est référencé dans les tableaux suivants : " . implode(", ", $affectedTables);
                Alert::toast($errorMessage,'error');
            } else {
                Alert::toast($exception->getMessage(),'error');
            }
        }

        return  redirect()->back()->withInput();
    }

    private function getAffectedTables($errorMessage)
    {
        preg_match_all("/`(.+?)`/", $errorMessage, $matches);
        return $matches[1];
    }
}
